// replace #include <boost/tr1/regex.hpp> with
//         #include <regex>
#include <boost/tr1/regex.hpp>

#include <iostream>
#include <string>

// replace std::tr1:: with std:: in the source code
int main(){

  std::cout << std::endl;

  // regular expression for the email address
  std::string regExprStr(R"(([\w.%+-]+)@([\w.-]+\.[a-zA-Z]{2,4}))");

  // regular expression holder
  std::tr1::regex rgx(regExprStr);

  std::string email="From: Mathias Huber <mhuber@linux-magazin.de>\n"
                    "User-Agent: Thunderbird 2.0.0.24 (X11/20101027)\n"
                    "MIME-Version: 1.0\n"
                    "To: Rainer Grimm <rainer@grimm-jaud.de>\n"
                    "CC: Rainer Grimm <R.Grimm@science-computing.de>\n"
                    "Subject: Re: Neuer Artikel\n"
                    "References: <50ABFDEB.2060202@grimm-jaud.de>\n"
                    "In-Reply-To: <50ABFDEB.2060202@grimm-jaud.de>\n"
                    "X-Enigmail-Version: 0.95.0\n"
                    "Content-Type: text/plain; charset=ISO-8859-15\n"
                    "Content-Transfer-Encoding: 8bit\n"
                    "Message-Id: <20121121102930.B9326580@mail.linux-new-media.de>;\n";

  std::cout << email << std::endl << std::endl;

  // define an iterator over all emails
  std::tr1::sregex_token_iterator it(email.begin(),email.end(),rgx);
  std::tr1::sregex_token_iterator end;

  // iterate over the emails
  while (it != end) std::cout << *it++ << std::endl;

  std::cout << std::endl;

  // define an iterator over all capture groups
  std::tr1::sregex_token_iterator itCaptureBegin(email.begin(),email.end(),rgx,{{1,2}});
  std::tr1::sregex_token_iterator itCaptureEnd;

  // iterate over the capture groups
  while(itCaptureBegin != itCaptureEnd){
    std::cout << *itCaptureBegin++ << "    ";
    std::cout << *itCaptureBegin++ << std::endl;
  }

  std::cout << std::endl;

}
